/*///////////////////////////////////////////////////////
 
            Paramètrage Minimod/Arduino 
  Envoi de lignes de commandes complètes via port COM        
  afin de programmer 5 modes d'émission présélectionnés.
  
  
 Mon site  http://F5mna.free.fr
   Version 02 Octobre 2015
 *////////////////////////////////////////////////////// 

#include <EEPROM.h>

//LCD
#include <LiquidCrystal.h>
// LCD RS pin to digital pin 8
// LCD Enable pin to digital pin 9
// LCD D4 pin to digital pin 4
// LCD D5 pin to digital pin 5
// LCD D6 pin to digital pin 6
// LCD D7 pin to digital pin 7
// LCD R/W pin to ground
LiquidCrystal lcd(8, 9, 4, 5, 6, 7);

const int BtSelec = 10;
const int BtValid = 11;

int EtatBtSelec, EtatBtValid, ValBtSelec, ValBtValid, Cdes ;

int DerEtatBtSelec = LOW;
int DerEtatBtValid = LOW;
long DerTempsRebond = 0;
long DelaiRebond = 50;

////////////////////////////////////////////////////////////////////////////
//  Lignes à modifier selon émissions choisies  //
////////////////////////////////////////////////////////////////////////////
//                     "                "                   
    char Commande1[] =  "    1255 DVBS  ";  // 1255 DVBS  SR 2500  Gain 10  FEC 3/4  
    int DVB_s_t1 = 1;                       //1 pour DVBS, 2 pour DVBT
    int FREQ1 = 1255;                       //Fréquence en MHz
    int SR1  = 2500;                        //SR
    int GAIN1= 10;                           //Gain (de 1 à 15).                     
    int FEC1 = 3 ;                          //1 FEC 1/2, 2 FEC 2/3, 3 FEC 3/4, 4 FEC 5/6 
    
    char Commande2[] =  "    1267 DVBS ";  // 1267 DVBS  SR 2500  Gain 10  FEC 3/4  
    int DVB_s_t2 = 1;                       //1 pour DVBS, 2 pour DVBT
    int FREQ2 = 1267;                       //Fréquence en MHz
    int SR2  = 2500;                        //SR
    int GAIN2= 10;                           //Gain (de 1 à 15)
    int FEC2 = 3 ;                          //1 FEC 1/2, 2 FEC 2/3, 3 FEC 3/4, 4 FEC 5/6 
    
    char Commande3[] =  "    1280 DVBS  ";  //1280 DVBS  SR 2500  Gain 10  FEC 3/4    
    int DVB_s_t3 = 1;                       //1 pour DVBS, 2 pour DVBT
    int FREQ3 = 1280;                        //Fréquence en MHz
    int SR3  = 2500;                        //SR
    int GAIN3= 10;                           //Gain (de 1 à 15)
    int FEC3 = 3 ;                          //1 FEC 1/2, 2 FEC 2/3, 3 FEC 3/4, 4 FEC 5/6                        
 
   char Commande4[] =  "    2300 DVBS "; // 450 + 1850 = 2330 MHz, SR 2500, gain 8, FEC 3/4 (OL Mélangeur)
    int DVB_s_t4= 1;                        //1 pour DVBS, 2 pour DVBT
    int FREQ4 = 450;                       //Fréquence en MHz
    int SR4  = 2500;                        //SR
    int GAIN4= 8;                           //Gain (de 1 à 15)
    int FEC4 = 3 ;                          //1 FEC 1/2, 2 FEC 2/3, 3 FEC 3/4, 4 FEC 5/6   
   
   char Commande5[] =  "    437 DVBS "; // 508 + 1850 = 2308 MHz, SR 2500, gain 8, FEC 3/4
    int DVB_s_t5= 1;                        //1 pour DVBS, 2 pour DVBT
    int FREQ5 = 437;                        //Fréquence en MHz
    int SR5  = 1500;                        //SR
    int GAIN5= 8;                           //Gain (de 1 à 15)
    int FEC5 = 3 ;                          //1 FEC 1/2, 2 FEC 2/3, 3 FEC 3/4, 4 FEC 5/6

   char Commande6[] =  "    437 DVBT  ";   // 437 DVBT  Gain 12  FEC 1/2  
   int DVB_s_t6 = 2;                       //1 pour DVBS, 2 pour DVBT
   int FREQ6 = 437;                        //Fréquence en MHz
 // int SR6  = 1500;                       // Pas de SR e DVBT
   int GAIN6= 12;                          //Gain (de 1 à 15)
   int FEC6 = 1 ;                          //1 FEC 1/2, 2 FEC 2/3, 3 FEC 3/4, 4 FEC 5/6 
 //////////////////////////////////////////////////////////////////////////  

void setup ()
{
  Serial.begin (115200);
  pinMode (BtSelec, INPUT);
  pinMode (BtValid, INPUT);
  Cdes = 1;
  
  lcd.begin(16, 2);
  lcd.setCursor(0, 0);
  lcd.print ("Controle Serial");
  lcd.setCursor(0, 1);
  lcd.print ("F5MNA  Version 1");
  delay(2000);
  lcd.clear ();
  lcd.setCursor(0, 0);
  lcd.print ("  Selection ");
  Cdes = EEPROM.read (1);
  lcd.print (Cdes);
  lcd.print ("/6");
  lcd.setCursor (0,1);
    switch (Cdes)
     {
    case 1: 
    lcd.print (Commande1);
    break;
    case 2:
    lcd.print (Commande2);
      break;
    case 3:
    lcd.print (Commande3);
      break;
    case 4:
    lcd.print (Commande4);
      break;
    case 5:
     lcd.print (Commande5);
      break;
    case 6:
     lcd.print (Commande6);
      break; 
     } 
 }

void loop ()
{
  
  ///////////  Bouton Selec  /////////////////
  ////////////////////////////////////////////

    int reading1 = digitalRead(BtSelec);
    if (reading1 != DerEtatBtSelec)  DerTempsRebond = millis();
    if ((millis() - DerTempsRebond) > DelaiRebond) {
      if (reading1 != EtatBtSelec) {
        EtatBtSelec = reading1;
        if (EtatBtSelec == HIGH)     
         {
         Cdes = Cdes + 1;
         if (Cdes > 6) Cdes = 1;
         lcd.clear();
         lcd.setCursor (2,0);
         lcd.print ("Selection ");
         lcd.print (Cdes);
         lcd.print ("/6");
         lcd.setCursor (0,1);
    switch (Cdes)
     {
    case 1: 
    lcd.print (Commande1);
    break;
    case 2:
    lcd.print (Commande2);
      break;
    case 3:
    lcd.print (Commande3);
      break;
    case 4:
    lcd.print (Commande4);
      break;
    case 5:
    lcd.print (Commande5);
    break;
    case 6:
    lcd.print (Commande6);
    break;
  }  }
  } 
  }   
       DerEtatBtSelec = reading1;
  ///////////  Bouton Valid  /////////////
  ////////////////////////////////////////

  int reading2 = digitalRead(BtValid);
  if (reading2 != DerEtatBtValid) DerTempsRebond = millis();
    if ((millis() - DerTempsRebond) > DelaiRebond) {
      if (reading2 != EtatBtValid) {
        EtatBtValid = reading2;       
 
 if ((EtatBtSelec == LOW) && (EtatBtValid == HIGH)) 

 {  
 switch (Cdes)
     {
    case 1:     
 // 1255 DVBS  SR 2500  Gain 10  FEC 3/4 
    Serial.println ("0");
    Serial.print   ("31");
    Serial.println (DVB_s_t1);//DVBS
    Serial.println ("0");
    Serial.print   ("33");
    Serial.print   (FREQ1);  // Frequence
    Serial.println ("000");
    Serial.println ("0");
    Serial.print   ("37");   // SR
    Serial.println (SR1);
    Serial.println ("0");
    Serial.print ("36");     // Gain
    Serial.println (GAIN1);
    Serial.println ("0");
    Serial.print ("38");     // FEC: ATTENTION 38 en DVBS et 37 en DVBT
    Serial.println (FEC1); 
    Serial.println ("0");      
    break;
   
    case 2:
   // 1267 DVBS  SR 2500  Gain 10  FEC 3/4 
    Serial.println ("0");
    Serial.print   ("31");
    Serial.println (DVB_s_t2);//DVBS
    Serial.println ("0");
    Serial.print   ("33");
    Serial.print   (FREQ2);  // Frequence
    Serial.println ("000");
    Serial.println ("0");
    Serial.print ("36");     // Gain
    Serial.println (GAIN2);
    Serial.println ("0");
    Serial.print   ("37");   // SR
    Serial.println (SR2);
    Serial.println ("0");
    Serial.print ("38");     // // FEC: ATTENTION 38 en DVBS et 37 en DVBT
    Serial.println (FEC2); 
    Serial.println ("0");      
    break;
    
    break;
    
    case 3:
   // 1280 DVBS  SR 2500  Gain 10  FEC 3/4 
    Serial.println ("0");
    Serial.print   ("31");
    Serial.println (DVB_s_t3);//DVBS
    Serial.println ("0");
    Serial.print   ("33");
    Serial.print   (FREQ3);  // Frequence
    Serial.println ("000");
    Serial.println ("0");
    Serial.print   ("37");   // SR
    Serial.println (SR3);
    Serial.println ("0");
    Serial.print ("36");     // Gain
    Serial.println (GAIN3);
    Serial.println ("0");
    Serial.print ("38");     // FEC: ATTENTION 38 en DVBS et 37 en DVBT
    Serial.println (FEC3); 
    Serial.println ("0");      
    break;

    case 4:
   // 2330 DVBS  SR 2500  Gain 10  FEC 3/4
    Serial.println ("0");  
    Serial.print   ("31");
    Serial.println (DVB_s_t4);//DVBS
    Serial.println ("0");  
    Serial.print   ("33");
    Serial.print   (FREQ4);   // Frequence
    Serial.println ("000");
    Serial.println ("0");
    Serial.print   ("37");   // SR
    Serial.println (SR4);
    Serial.println ("0");
    Serial.print ("36");     // Gain
    Serial.println (GAIN4);
    Serial.println ("0");
    Serial.print ("38");     // FEC: ATTENTION 38 en DVBS et 37 en DVBT
    Serial.println (FEC4); 
    Serial.println ("0");  
    break;
    
   case 5:
   // 437 DVBS  SR 1500  Gain 10  FEC 3/4 
    Serial.println ("0");
    Serial.print   ("31");
    Serial.println (DVB_s_t5);//DVBS
    Serial.println ("0");
    Serial.print   ("33");
    Serial.print   (FREQ5);  // Frequence
    Serial.println ("000");
    Serial.println ("0");
    Serial.print   ("37");   // SR
    Serial.println (SR5);
    Serial.println ("0");
    Serial.print ("36");     // Gain
    Serial.println (GAIN5);
    Serial.println ("0");
    Serial.print ("38");     // FEC: ATTENTION 38 en DVBS et 37 en DVBT
    Serial.println (FEC5); 
    Serial.println ("0");      
    break; 
    
    case 6:
   // 437 DVBT  BP6 //SR 1500  Gain 12  FEC 1/2 
    Serial.println ("0");
    Serial.print   ("31");
    Serial.println (DVB_s_t6);//DVBT
    Serial.println ("0");
    Serial.print   ("33");
    Serial.print   (FREQ6);  // Frequence
    Serial.println ("000");
    Serial.println ("0");
   // Serial.print   ("37");   // SR
   // Serial.println (SR3);
   // Serial.println ("0");
    Serial.print ("36");     // Gain
    Serial.println (GAIN6);
    Serial.println ("0");
    Serial.print ("37");     // FEC: ATTENTION 38 en DVBS et 37 en DVBT
    Serial.println (FEC6); 
    Serial.println ("0");      
    break;  
   } 
   lcd.setCursor (2,0);
   lcd.print ("                 ");
   lcd.setCursor (5,0);
   lcd.print ("* ");
   delay (1000);
   lcd.print ("* ");
   delay (1000);
   lcd.print ("* ");
   delay (1000);
   lcd.print ("* ");
   delay (1000);
   lcd.setCursor (2,0);
   lcd.print ("EMISSION ");
   lcd.print (Cdes);
   lcd.println ("/6  ");  
 
  }
    EEPROM.write (1, Cdes); 
} }
DerEtatBtValid = reading2; 
}


